window.Gleam.initSearch([{"doc":"stego","title":"stego","content":"# Stego\n\n`Deno.serve` for Gleam ✨\n\n[Read the documentation](https://hexdocs.pm/stego)\n\n```gleam\nimport gleam/http/response\nimport gleam/javascript/promise\nimport stego\n\npub fn main() {\n  stego.serve(fn (_request) {\n    response.new(200)\n    |&gt; response.set_header(&quot;content-type&quot;, &quot;text/html; charset=utf-8&quot;)\n    |&gt; response.set_body(&quot;&lt;h1&gt;hoi!&lt;/h1&gt;&quot;)\n    |&gt; promise.resolve()\n  })\n}\n```\n","url":"index.html"},{"doc":"stego/body","title":"Body","content":"pub type Body\n Represents a request body received from a client. This value is consumed when read,\n meaning it can only be read once.\n https://developer.mozilla.org/en-US/docs/Web/API/Request#instance_methods\n\nSynonyms:\nstego/body.Body\nstego/body Body","url":"stego/body.html#Body"},{"doc":"stego/body","title":"bit_array","content":"pub fn bit_array(body: Body) -&gt; Promise(BitArray)\n Parse the request body as binary, and receive it as a `BitArray`\n\n &lt;details&gt;\n &lt;summary&gt;Examples&lt;/summary&gt;\n\n \n import gleam/javascript/promise\n import stego/body\n\n use bytes &lt;- promise.await(\n   request.body\n   |&gt; body.bit_array()\n )\n \n\n &lt;/details&gt;\n\nSynonyms:\nstego/body.bit_array\nstego/body bit_array","url":"stego/body.html#bit_array"},{"doc":"stego/body","title":"json","content":"pub fn json(body: Body) -&gt; Promise(Dynamic)\n Parse the request body as JSON, and receive it as a `Dynamic`\n\n &lt;details&gt;\n &lt;summary&gt;Examples&lt;/summary&gt;\n\n \n import gleam/dynamic\n import gleam/javascript/promise\n import gleam/json\n import stego/body\n\n use puppy_json &lt;- promise.await(\n   request.body\n   |&gt; body.json()\n )\n\n dynamic.decode3(\n   Puppy,\n   dynamic.field(&quot;name&quot;, of: dynamic.string),\n   dynamic.field(&quot;good&quot;, of: dynamic.bool),\n   dynamic.field(&quot;soft&quot;, of: dynamic.bool),\n )\n |&gt; json.decode(from: puppy_json)\n \n\n &lt;/details&gt;\n\nSynonyms:\nstego/body.json\nstego/body json","url":"stego/body.html#json"},{"doc":"stego/body","title":"text","content":"pub fn text(body: Body) -&gt; Promise(String)\n Parse the request body as text, and receive it as a `String`\n\n &lt;details&gt;\n &lt;summary&gt;Examples&lt;/summary&gt;\n\n \n import gleam/javascript/promise\n import stego/body\n\n use text &lt;- promise.await(\n   request.body\n   |&gt; body.text()\n )\n \n\n &lt;/details&gt;\n\nSynonyms:\nstego/body.text\nstego/body text","url":"stego/body.html#text"},{"doc":"stego/body","title":"stego/body","content":"","url":"stego/body.html"},{"doc":"stego","title":"Body","content":"pub type Body =\n  body.Body\n\n\nSynonyms:\nstego.Body\nstego Body","url":"stego.html#Body"},{"doc":"stego","title":"serve","content":"pub fn serve(\n  server: fn(Request(Body)) -&gt; Promise(Response(a)),\n) -&gt; Nil\n ### `Deno.serve`, but for Gleam!\n\n `Deno.serve` allows you to create a server using the web standard\n [`Request`](https://developer.mozilla.org/en-US/docs/Web/API/Request) and\n [`Response`](https://developer.mozilla.org/en-US/docs/Web/API/Response) types.\n Stego translates between these types and Gleam&#39;s own\n [`Request`](https://hexdocs.pm/gleam_http/gleam/http/request.html) and\n [`Response`](https://hexdocs.pm/gleam_http/gleam/http/response.html) types.\n Your response body can be a `BitArray`, `String`, or `StringBuilder`.\n\n &lt;details&gt;\n &lt;summary&gt;Examples&lt;/summary&gt;\n\n \n import gleam/http/response\n import gleam/javascript/promise\n import stego\n\n pub fn main() {\n   stego.serve(fn (_request) {\n     response.new(200)\n     |&gt; response.set_header(&quot;content-type&quot;, &quot;text/html; charset=utf-8&quot;)\n     |&gt; response.set_body(&quot;&lt;h1&gt;hoi!&lt;/h1&gt;&quot;)\n     |&gt; promise.resolve()\n   })\n }\n \n\n &lt;/details&gt;\nSynonyms:\nstego.serve\nstego serve","url":"stego.html#serve"},{"doc":"stego","title":"stego","content":"","url":"stego.html"}]);